"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApolloResolverWrapper = exports.WrapApolloResolvers = exports.ApolloCallbackWrapper = void 0;
var graphql_parse_resolve_info_1 = require("graphql-parse-resolve-info");
function ApolloCallbackWrapper(cb, resolvers, resolverType) {
    return function (parent, args, context, info) {
        var resolving = __assign({ parent: parent, args: args, 
            // @ts-ignore
            context: context, 
            // @ts-ignore
            info: info, resolvers: resolvers[resolverType], resolverType: resolverType }, (info ? (0, graphql_parse_resolve_info_1.parseResolveInfo)(info) : {}));
        if (context && info) {
            return cb(args, context, resolving);
        }
        return cb(parent, args, context, info);
    };
}
exports.ApolloCallbackWrapper = ApolloCallbackWrapper;
function WrapApolloResolvers(resolvers) {
    var _loop_1 = function (resolverType) {
        var resolvers_ = resolvers[resolverType];
        if (Object.keys(resolvers_).length == 0) {
            delete resolvers[resolverType];
        }
        else {
            resolvers[resolverType] = Object.fromEntries(Object.entries(resolvers_).map(function (_a) {
                var key = _a[0], value = _a[1];
                return [key, ApolloCallbackWrapper(value, resolvers, resolverType)];
            }));
        }
    };
    for (var resolverType in resolvers) {
        _loop_1(resolverType);
    }
    return resolvers;
}
exports.WrapApolloResolvers = WrapApolloResolvers;
//** Used in delayed computation of wrapped callbacks */
/*
class mutations extends ApolloResolverWrapper {
    static collection = {
        rename
    };
}; new mutations();

mutations.collection; // { rename: wrapped(rename) }
*/
var ApolloResolverWrapper = /** @class */ (function () {
    function ApolloResolverWrapper(resolverType) {
        var groups = Object.getPrototypeOf(this).constructor;
        if (!resolverType) {
            var name_1 = groups.name.toLowerCase();
            if (name_1.includes('mut')) {
                resolverType = 'Mutation';
            }
            else if (name_1.includes('que')) {
                resolverType = 'Query';
            }
            else if (name_1.includes('sub')) {
                resolverType = 'Subscription';
            }
            else {
                resolverType = '';
            }
        }
        var _loop_2 = function (key) {
            var resolvers = groups[key];
            var wrappedKey = '_' + key;
            Object.defineProperty(groups, key, {
                get: function () {
                    if (wrappedKey in this)
                        return this[wrappedKey];
                    var _resolvers = __assign({}, resolvers);
                    for (var name_2 in resolvers) {
                        _resolvers[name_2] = ApolloCallbackWrapper(resolvers[name_2], _resolvers, resolverType);
                    }
                    this[wrappedKey] = _resolvers;
                    return this[key];
                }
            });
        };
        for (var key in groups) {
            _loop_2(key);
        }
    }
    return ApolloResolverWrapper;
}());
exports.ApolloResolverWrapper = ApolloResolverWrapper;
